##########################################################################################
#
# ѥե륿ץ饰ʳؽǽ̵ǡ
#bugtrackץ饰ΥС饤ɡ
#
##########################################################################################
use strict;

use plugin::bugtrack::BugTrackHandler;

# plugin::bugtrack::BugTrackHandlerdo_action᥽åɤ֤
package plugin::bugtrack::BugTrackHandler;

sub do_action {
	my $self = shift;
	my $wiki = shift;
	my $cgi = $wiki->get_CGI;
	
	my $project  = $cgi->param("project");
	my $name     = $cgi->param("name");
	my $category = $cgi->param("category");
	my $priority = $cgi->param("priority");
	my $status   = $cgi->param("status");
	my $content  = $cgi->param("content");
	my $subject  = $cgi->param("subject");
	my $time     = time();
	
	if($name eq ""){
		return $wiki->error("̾ϤƤޤ");
	} elsif($subject eq ""){
		return $wiki->error("ޥ꤬ϤƤޤ");
	} elsif($content eq ""){
		return $wiki->error("ХƤϤƤޤ");
	}
	
	# post_nameȤǥå򥻥åȤ
	my $path   = &Util::cookie_path($wiki);
	my $cookie = $cgi->cookie(-name=>'post_name',-value=>$name,-expires=>'+1M',-path=>$path);
	print "Set-Cookie: ",$cookie->as_string,"\n";
	
#--------------------------------------------------------------------------------------------------
  if($content){
    unless(&plugin::_ex_spam_filter_light::Install::judgment_text($content)){
      my $time = Util::format_date(time());
      my $file = $wiki->config('log_dir')."/spam_bugtrack.txt";
      if(open(SPAM_LOG, ">>$file")){
        print SPAM_LOG "-" x 70 . "\n";
        print SPAM_LOG "$project:$name:$category:$priority:$status:$time\n";
        print SPAM_LOG "-" x 70 . "\n";
        print SPAM_LOG "$content\n";
        close(SPAM_LOG);
      }
      my $error_message = $wiki->error("Ƥ줿ʸϤϥѥåȽꤵޤ\n");
      $subject = Util::escapeHTML($subject);
      $content = Util::escapeHTML($content);
      $content =~ s/\n/<br>/g;
      $error_message .= "<p>\n";
      $error_message .= "<div>Ƥ줿ʸϡ</div>\n";
      $error_message .= "<div>Ƽԡ$name</div>\n";
      $error_message .= "<div>㥫ƥ$category</div>\n";
      $error_message .= "<div>ͥ١$priority</div>\n";
      $error_message .= "<div>֡$status</div>\n";
      $error_message .= "<div>$time</div>\n";
      $error_message .= "<div>ʸ</div>\n";
      $error_message .= "<div>$content</div>\n";
      $error_message .= "</p>\n";
      return $error_message;
    }
  }
#--------------------------------------------------------------------------------------------------

	# եޥåȥץ饰ؤб
	my $format = $wiki->get_edit_format();
	$name     = $wiki->convert_to_fswiki($name    ,$format,1);
	$category = $wiki->convert_to_fswiki($category,$format,1);
	$priority = $wiki->convert_to_fswiki($priority,$format,1);
	$status   = $wiki->convert_to_fswiki($status  ,$format,1);
	$content  = $wiki->convert_to_fswiki($content ,$format);
	
	my $page = $self->make_pagename($wiki,$project);
	
	$content = "!!!$subject\n".
	           "*Ƽԡ $name\n".
	           "*ƥꡧ $category\n".
	           "*ͥ١ $priority\n".
	           "*֡ $status\n".
	           "* ".Util::format_date($time)."\n".
	           "{{bugstate}}\n".
	           "!!\n".$content."\n".
	           "!!\n{{comment}}";
	
	$wiki->save_page($page,$content);
	$wiki->redirect($page);
}

1;
